summaryrefslogtreecommitdiff
path: root/tests/misc/uniq
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-05-14 09:37:02 +0200
committerJim Meyering <meyering@redhat.com>2008-05-17 08:27:58 +0200
commit1081bbc74e48010700783a9bb82a4657d1d02bd2 (patch)
tree41694f8ec4c2400349a367bb3680db8f09951438 /tests/misc/uniq
parentea54b6f47c92525267861e15314c61db83a86352 (diff)
downloadcoreutils-1081bbc74e48010700783a9bb82a4657d1d02bd2.tar.xz
tests: remove ugly /bin/sh wrapper around each perl-based test script
* tests/check.mk (TESTS_ENVIRONMENT): Save and restore TMPDIR around envvar-check, so that the few scripts that require $TMPDIR don't fail. This is also good to let a user's default TMPDIR setting be used e.g., in the search for an 'other-partition'. FIXME: this is pretty ugly. maybe undo it and find a better way. (TESTS_ENVIRONMENT): Invoke perl scripts with $(PERL), and use -T if the script requires that. Otherwise, use $(SHELL). * tests/misc/md5sum-newline: Create a file whose name contains a newline in Perl (resort to using "system", since open refuses). Fix old brokenness exposed by this change: * tests/du/files0-from: Correct test not to rely on stdin being attached to a non-tty. * tests/misc/sort (3g, 3h, 3i): Likewise: add explicit empty input file. Avoid warnings about using qw()-around-commas. * tests/rm/fail-eperm: Now that this test is run from a temporary subdirectory, adjust the full name of the "rm" program we're going to run. Change #!/bin/sh to #!/usr/bin/perl, and factor out the few lines of boilerplate code to invoke perl. Do not "require 5.00x"; a configure-time Perl test handles that * tests/dd/skip-seek: * tests/misc/base64: * tests/misc/basename: * tests/misc/cut: * tests/misc/date: * tests/misc/dircolors: * tests/misc/dirname: * tests/misc/expand: * tests/misc/expr: * tests/misc/factor: * tests/misc/fmt: * tests/misc/fold: * tests/misc/head: * tests/misc/head-elide-tail: * tests/misc/join: * tests/misc/ls-misc: * tests/misc/md5sum: * tests/misc/md5sum-newline: * tests/misc/mktemp: * tests/misc/od: * tests/misc/paste: * tests/misc/pr: * tests/misc/printf-cov: * tests/misc/seq: * tests/misc/sha1sum: * tests/misc/sha1sum-vec: * tests/misc/sha224sum: * tests/misc/sha256sum: * tests/misc/sha384sum: * tests/misc/sha512sum: * tests/misc/sort-merge: * tests/misc/stat-printf: * tests/misc/sum: * tests/misc/tac: * tests/misc/tail: * tests/misc/test: * tests/misc/test-diag: * tests/misc/tr: * tests/misc/tsort: * tests/misc/tty-eof: * tests/misc/unexpand: * tests/misc/uniq: * tests/misc/wc: * tests/misc/wc-files0-from: * tests/misc/xstrtol: * tests/mv/i-1: * tests/pr/pr-tests: * tests/rm/empty-name: * tests/rm/fail-eperm: * tests/rm/unreadable:
Diffstat (limited to 'tests/misc/uniq')
-rwxr-xr-xtests/misc/uniq21
1 files changed, 8 insertions, 13 deletions
diff --git a/tests/misc/uniq b/tests/misc/uniq
index 1c85735a2..0350864c0 100755
--- a/tests/misc/uniq
+++ b/tests/misc/uniq
@@ -1,5 +1,5 @@
-#!/bin/sh
-# Test for a subtle, system-and-locale-dependent bug in uniq.
+#!/usr/bin/perl
+# Test uniq.
# Copyright (C) 2008 Free Software Foundation, Inc.
@@ -16,16 +16,6 @@
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
-case $LOCALE_FR in
-''|none) echo "$0: skipping this test -- no appropriate locale" 1>&2; exit 77;;
-esac
-
-: ${srcdir=.}
-. $top_srcdir/tests/require-perl
-
-me=`echo $0|sed 's,.*/,,'`
-exec $PERL -w -I$top_srcdir/tests -MCoreutils -M"CuTmpdir qw($me)" -- - <<\EOF
-require 5.003;
use strict;
my $prog = 'uniq';
@@ -90,6 +80,11 @@ sub add_z_variants($)
# I've only ever triggered the problem in a non-C locale.
my $locale = $ENV{LOCALE_FR};
+if (! defined $locale || $locale eq 'none')
+ {
+ warn "$prog: skipping this test -- no appropriate locale\n";
+ exit 77;
+ }
# See if isblank returns true for nbsp.
my $x = `env printf '\xa0'| LC_ALL=$locale tr '[:blank:]' x`;
@@ -100,6 +95,7 @@ my $schar_exp = $x eq 'x' ? " y z\n" : $in;
my @Tests =
(
+ # Test for a subtle, system-and-locale-dependent bug in uniq.
['schar', '-f1', {IN => $in}, {OUT => $schar_exp},
{ENV => "LC_ALL=$locale"}],
['1', '', {IN=>''}, {OUT=>''}],
@@ -217,4 +213,3 @@ my $verbose = $ENV{VERBOSE};
my $fail = run_tests ($prog, $prog, \@Tests, $save_temps, $verbose);
exit $fail;
-EOF